
#ifdef WIN32
	#include <windows.h>
	#pragma comment(lib, "Irrlicht.lib")
#endif

#include <irrlicht.h>

using namespace irr;
using namespace core;
using namespace video;
using namespace scene;

#include <stdarg.h>

enum DEFINE
{
	FONT_SIZE = 12,
};

/**
 * @brief 摜\
 * @param driver irrlichtrfIhCo
 * @param filename \摜t@C
 * @param x \XW
 * @param y \YW
 * @param w \
 * @param h \
 * @param u 摜ǂݍXW
 * @param v 摜ǂݍYW
 * @param bColorKey J[L[gp邩ǂ
 * @param colLU ̐F
 * @param colLD ̐F
 * @param colRD E̐F
 * @param colRU E̐F
 * @param sx Xgk 1={
 * @param sy Ygk 1={
 * @return 1:IA0:ُI
 */
int drawImage(IVideoDriver* driver, char* filename, int x, int y, int w, int h, int u, int v, 
		   bool bColorKey, SColor colLU, SColor colLD, SColor colRD, SColor colRU, float sx, float sy)
{
	//G[`FbN
	if(driver == NULL || filename == NULL || strlen(filename) == 0)
		return 0;

	ITexture* texture = driver->getTexture(filename);
	SColor colors[] = {colLU,colLD,colRD,colRU};//FFEFE
	if(colLD == 0)
		colors[1] = colors[2] = colors[3] = colLU;
	if(bColorKey)
	{
		//J[L[(Fw)
		driver->makeColorKeyTexture(texture, 0x00000000);
		//J[L[(ꏊw)
		//driver-&gtmakeColorKeyTexture(texture, position2d<s32>(0,0));
	}
	driver->draw2DImage(texture, rect<s32>(x,y,x+w*sx,y+h*sy), rect<s32>(u,v,u+w,v+h), 0, colors, true);

	return 1;
}

/**
 * @brief `
 * @param driver irrlichtrfIhCo
 * @param x `XW
 * @param y `YW
 * @param color `F
 * @param fmt `悷镶tH[}bg
 * @return 0ȏ:񂾕A-1:ُI
 */
int drawString(IVideoDriver* driver, int x, int y, SColor color, const char* fmt, ...)
{
	int i,len, cnt;
	va_list ap;
	char tmp[1024];
	char *tex = "japanese.png";

	if(driver == NULL)
		return -1;

	memset(tmp, 0x00, sizeof(tmp));

	//t𒲐
	va_start(ap, fmt);
	vsprintf(tmp, fmt, ap);
	va_end(ap);

	cnt = 0;
	len = strlen(tmp);

	int posx = 0;			//̕`ʒu
	int posy = 0;			//̕_ʒu
	int tx, ty;				//摜ǂݍ݈ʒu
	int w;					//̕
	int h = FONT_SIZE;		//̍
	unsigned char buf[2];	//擾ꎞۑ
	
	for(i=0;i<len;i++)
	{
		buf[0] = tmp[i]&0xFF;
		
		//i[hG`FbN
		if(buf[0] == 0xF8 || buf[0] == 0xF9)
		{
			w = FONT_SIZE;
			buf[1] = tmp[++i]&0xFF;//̃obt@擾
			//摜ʒuvZ
			tx = (buf[1]%64)*h;						
			ty = 73*FONT_SIZE+(buf[0]-0xF8)*FONT_SIZE*4+(buf[1]/64)*h;
			drawImage(driver,tex,x+posx,y+posy,w,h,tx,ty,0,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,1,1);
			posx += w;

			cnt+=2;
		}
		//2oCg`FbN
		else if((buf[0] >= 0x80 && buf[0] <= 0x9F) || buf[0] >= 0xE0)
		{
			//2oCg
			w = FONT_SIZE;
			buf[1] = tmp[++i]&0xFF;//̃obt@擾
			//摜ʒuvZ
			tx = ((buf[1]-0x40)%64)*h;						
			ty = (1+(buf[0]-0x81)*3+(buf[1]-0x40)/64)*h;
			drawImage(driver,tex,x+posx,y+posy,w,h,tx,ty,0,color,color,color,color,1,1);
			posx += w;
			cnt += 2;
		}
		//1oCg
		else
		{
			//1oCg
			w = FONT_SIZE/2;
			switch(buf[0])
			{
				//s
				case '\n':
					posx = 0;		//Jnʒu0ɂ
					posy += h;		//̍炷
					break;
				//^u
				case '\t':
					posx += w*4;	//p4炷
					cnt += 4;
					break;
				//ʏ핶
				default:
					//pJi
					if(buf[0] >= 0xA0 && buf[0] <= 0xDF)
					{
						//摜ʒuvZ
						tx = (buf[0]-0xA0)*w;
						ty = 72*FONT_SIZE;
					}
					//p
					else
					{
						//摜ʒuvZ
						tx = (buf[0]-0x20)*w;
						ty = 0;
					}
					drawImage(driver,tex,x+posx,y+posy,w,h,tx,ty,0,color,color,color,color,1,1);
					posx += w;

					cnt += 1;

					break;
			}
		}
	}
	return cnt;
}

/**
 * @brief V[쐬
 * @param driver irrlichtrfIhCo
 * @return Ȃ
 */
void makeScene(IVideoDriver* driver)
{
	//i[h\
	drawString(driver,0,12*1,0xFFFFFFFF, "");
	drawString(driver,0,12*2,0xFFFFFFFF, "");
	drawString(driver,0,12*3,0xFFFFFFFF, "");
	drawString(driver,0,12*4,0xFFFFFFFF, "");
	drawString(driver,0,12*5,0xFFFFFFFF, "");
	drawString(driver,0,12*6,0xFFFFFFFF, "@A");
	drawString(driver,0,12*7,0xFFFFFFFF, "BCDEFGHIPQRUVW[\");
	drawString(driver,0,12*8,0xFFFFFFFF, "]^rstuvwxyz{|}~");
	drawString(driver,0,12*9,0xFFFFFFFF, "");
	drawString(driver,0,12*10,0xFFFFFFFF, "");
	drawString(driver,0,12*11,0xFFFFFFFF, "");
	drawString(driver,0,12*12,0xFFFFFFFF, "");
	drawString(driver,0,12*13,0xFFFFFFFF, "");
	drawString(driver,0,12*14,0xFFFFFFFF, "");
	drawString(driver,0,12*15,0xFFFFFFFF, "");
	drawString(driver,0,12*16,0xFFFFFFFF, "");
	drawString(driver,0,12*17,0xFF000000, "pýĕ\");
}

/** 
 * @brief C
 * @param hInstance ݂̃CX^X
 * @param hPrevInstance ȑÕCX^X
 * @param lpCmdLine R}hC
 * @param nCmdShow EChE\p^[
 * @param argc ̐
 * @param argv z
 * @return 1:I
 */
#if !defined(_CONSOLE) && defined(WIN32)   
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)   
#else   
int main (int argc, char* argv[])   
#endif  
{
	IrrlichtDevice* device = createDevice(EDT_OPENGL,dimension2d<s32>(240,240),16,false,false,0);
	IVideoDriver*   driver = device->getVideoDriver();
	ISceneManager*  smgr   = device->getSceneManager();

	device->setWindowCaption(L"Irrlicht");//EChE^Cgݒ

	//Cg
	smgr->addLightSceneNode(0, vector3df(0,0,-1000), SColorf(0xFFFFFFFF), 1000.0f);

	//Jݒ
	smgr->addCameraSceneNode(0, vector3df(0,0,-5), vector3df(0,0,0));

	while(device->run())
	{
		driver->beginScene(true,true,0xFFFFFFFF);

		//}`쐬
		makeScene(driver);

		//V[̕`
		smgr->drawAll();

		driver->endScene();

		Sleep(10);//CPU̕גAG[oĉ
	}

	driver->drop();

	return 1;
}
